{-----------------------------------------------------------------------------}
{ Reading Interface of a unit (*.SYM).			   (c) 1989, 1990 YGP }

  (*) segment (*)
  function GetInterface(    name:     alpha;
			    UnitType: ImportType;
			var _ver,
			    _date,
			    _time:    cardinal;
			    UsedUnits: natural): idp;

    {$ifdef PSA}
    const MaxUnits = MaxCodeSz; 	    {  Pascal Structure Analyst }
    {$else}
    const MaxUnits = MaxCodeSz div (*) 2 {*) 4 {*} -1;
    {$endif}

    type CFH_ModD = packed record    { Code File Header and Module descriptor }
	   case integer of
	     0: (CODE:	  word; 		  { CodeFile const    ($C0DE) }
		 WrdSz:   byte; 		  { Word Size	      ($10)   }
		 ByteSex: byte; 		  { Byte Sex	      ($00)   }
		 VerMaj,			  { Version Major     (  1)   }
		 VerMin:  byte; 		  {	    Minor     ( 00)   }
		 Unused:  word; 		  { unused	      ($0000) }
		 PSize:   Cardinal;		  { Paragraph Size    ($0020) }
		 BSize:   Cardinal;		  { Block Size	      ($0200) }
		 Offset:  Cardinal;		  { Offset of ModDesc ($0001) }
		 boza:	  packed array [0..13] of char;    { fill to ParaSize }
		 SerNo:   LongWord);

	     1: (Mname: alpha;					{ Module name }
		 MDver, 				     { Module Version }
		 MDdate,					   { Date and }
		 MDtime:   Cardinal;			{ Time of compilation }
		 NextMod:  Cardinal;		     { Next Module Descriptor }
		 MainSeg:  Cardinal;		  { Paragraph of Main Segment }
		 Language: Cardinal;				   { Language }
		 CompStart,			     { Start of compiler info }
		 CompSize: Cardinal;			      { Compiler Size }
		 UsgList:  Cardinal;		       { Usage List paragraph }
		 U1, U2:   Cardinal;				     { unused }
		 NExtrnl,			   { Number of External units }
		 NIntrnl:  ShortCard);		    { Number of Internal Segs }
	 end { CFH_ModD };

	 LvlArray = array [0 .. MaxUnits] of levelp;

    var utt: ^LvlArray; 			       { Unit Translate Table }
	ulvl: levelp;
	widp,
	uidp: idp;
	vdt:  record v, d, t: cardinal end;	      { version date and time }
	LibFile: file;

    procedure FromLib(var buffer; size: natural);
    begin
      BlockRead(LibFile, buffer, size);
      if IOresult <> 0 then begin
	errsy:= c_const; error(246);
      end { if };
    end { FromLib };

    function AlreadyUsed: boolean;
      var lidp: idp;
    begin
      AlreadyUsed:= true;
    {$ifdef UniPas }		   {        }

      if not QueueSearch(Units, 2, 6, lidp, name, $0880) then begin
	lidp:= nil;
      end { if };

    {$else}

      lidp:= Units;
      while (lidp <> nil) and (lidp^.IdName <> name) do begin
	lidp:= lidp^.next;
      end { while };

    {$endif}

      if lidp = nil then
	AlreadyUsed:= false
      else begin	    {   ,       }
	GetInterface:= lidp;
	with lidp^.Intface^ do begin
	  if (_ver = 0) and (_date = 0) and (_time = 0) then begin
	    _ver:= ver; _date:= date; _time:= time; end
	  else begin
	    if _ver = ver then begin {       }
	      if (_date <> date) or (_time <> time) then begin	  {   }
		error(245)
	      end { if }; end
	    else if _ver < ver then begin  {     - }
	      if (date < _date) or (time < _time) then begin	{    }
		error(245)			 { ?    ' ' }
	      end { if }; end
	    else begin
	      error(245)				   {    }
	    end { if };
	  end { if };
	end { with };
      end { if };
    end { AlreadyUsed };

    function CheckStart: boolean;
      var istrt: packed record
	    UniPascal: packed array [0..9] of char;	      { 'UniPascal'#0 }
	    SYMverMaj,
	    SYMverMin: shortcard;
	    SrNo:      LongWord;
	    SYMunitnm: alpha;
	    SYMver,
	    SYMdate,
	    SYMtime:   cardinal;
	  end { istrt };
    begin
      FromLib(istrt, SizeOf(istrt));
      if (istrt.UniPascal <> 'UniPascal'#0) or
	 (1 <> istrt.SYMverMaj) or (istrt.SYMverMin <> 51) then begin
	errsy:= c_const; error(244);
      end { if };

      if (istrt.SYMunitnm <> name) then
	CheckStart:= false
      else begin
	move(istrt.SYMver, vdt, sizeof(vdt));	     {    ) }
	if (_ver = 0) and (_date = 0) and (_time = 0) then begin
	  _ver:= istrt.SYMver; _date:= istrt.SYMdate; _time:= istrt.SYMtime end
	else begin
	  if _ver = istrt.SYMver then begin {     }
	    if (_date <> istrt.SYMdate) or (_time <> istrt.SYMtime) then begin
	      error(245)
	    end { if }; end
	  else if _ver < istrt.SYMver then begin    {     }
	    if (istrt.SYMdate < _date) or (istrt.SYMtime < _time) then begin
	      error(245)	{ -    ?   ' ' }
	    end { if }; end
	  else begin
	    error(245)					   {    }
	  end { if };
	end { if };
	CheckStart:= true;
      end { if };
    end { CheckStart };

    function UnitNotFound: boolean;
      var pathNdx: integer;
	  c_m: CFH_ModD;
          blck_sz: natural;
	  Path: string[127];

      function TryThisPath((*) const (*) Path: string): boolean;
	var (*){*) FlMd: byte; {*}
	    SYMname: string[127];
      begin
	SYMname[0]:= #8; (*) {$W-} (*) move(name, SYMname[1], 8);
	while SYMname[length(SYMname)] = ' ' do dec(SYMname[0]);
	insert('.SYM', SYMname, length(SYMname)+1);
	insert(path, SYMname, 1);
	last.S:= addr(SYMname);
{$ifdef DBGgetI}
writeln('<looking for ', SYMname, '>');
{$endif}
	(*) reset (LibFile, SYMname);
	{*) FlMd:= FileMode; FileMode:= 0;		  (* input file only *)
	    assign(LibFile, SYMname); reset(LibFile, 1);
	    FileMode:= FlMd;						    {*}
	if IOresult <> 0 then begin
	  TryThisPath:= false;
	  (*) return() {*) exit {*};
	end { if };

	if CheckStart then begin
	  Seek(LibFile, 0); TryThisPath:= true; end
	else begin
	  TryThisPath:= false; Close(LIBfile); (*){*) if IOresult <> 0 then{*};
	end { if };
      end { TryThisPath };

      (*){*) var FlMd: byte;			   {   }
    begin
      UnitNotFound:= false;		      {    - }
		 {   (  )         }
      (*) reset (LibFile, LibName^);
      {*) FlMd:= FileMode; FileMode:= 0;		  (* input file only *)
	  assign(LibFile, LibName^); reset(LibFile, 1);
	  FileMode:= FlMd;						    {*}

      if IOresult = 0 then begin	   {  ,     }
			{          . }
	Last.S:= LibName;
	FromLib(c_m, SizeOf(c_m));
	if (c_m.CODE <> swap($c0de)) or
	   (c_m.WrdSz <> 16) or (c_m.ByteSex <> 0) or
	   (1 <> c_m.VerMaj) or
	   (50 < shortcard(c_m.VerMin and $7f)) or
           (c_m.PSize <> 32) (* Block Size correction from version 1.67
                               or (c_m.BSize <> 512) *) then begin
	  errsy:= c_const; error(244);
	end { if };

	c_m.nextmod:= c_m.offset; blck_sz:= c_m.Bsize;    { Block Size. v1.67 }
	while c_m.nextmod <> 0 do begin
	  with c_m do begin
	    Seek(LibFile, longint(nextmod) * 32);
	    if IOresult <> 0 then begin
	      errsy:= c_const; error(246);
	    end { if };
	    FromLib(c_m, SizeOf(c_m));
	    if Mname = name then begin		{       }
	      if (_ver = 0) and (_date = 0) and (_time = 0) then begin
		_ver:= MDver; _date:= swap(MDdate); _time:= swap(MDtime); end
	      else begin
		if _ver = MDver then begin {      }
		  if (_date <> MDdate) or (_time <> MDtime) then begin
		    error(245)
		  end { if }; end
		else if _ver < MDver then begin     {     }
		  if (MDdate < _date) or (MDtime < _time) then begin
		    error(245)	{ -    ?   ' ' }
		  end { if }; end
		else begin
		  error(245)				   {    }
		end { if };
	      end { if };
	      if CompStart <> 0 then begin
                {------------ Block Size corrected. version 1.67 -------------}
                Seek(LibFile, longint(CompStart) * blck_sz (*512*));
		if IOresult <> 0 then begin
		  errsy:= c_const; error(246);
		end { if };
  	        (*) return() {*) exit {*};
	      end { if };
	    end { if };
	  end { with };
	end { while };
	Close(LibFile); (*) {*) if IOresult <> 0 then; {*}
      end { if };

      {        ,      .SYM }
      pathNdx:= 1;
      if length(UsesPaths^) = 0 then
	UnitNotFound:= not TryThisPath('')
      else begin
	while pathNdx <= length(UsesPaths^) do begin
	  path:= '';
	  while UsesPaths^[pathNdx] <> ';' do begin
	    inc(path[0]); path[length(path)]:= UsesPaths^[pathNdx];
	    inc(pathNdx);
	  end { while };
	  if TryThisPath(path) then begin
	    (*) return () {*) exit {*};
	  end { if };
	  inc(pathNdx);
	end { while };
	UnitNotFound:= true;
      end { if };
    end { UnitNotFound };

    procedure GetAlpha(var a: alpha);
    begin
      FromLib(a, 8);
{$ifdef DBGgetI}
write('"', a, '",');
{$endif}
    end { GetAlpha };

    procedure GetLword(var l: longword);
    begin
      FromLib(l, 4);
{$ifdef DBGgetI}
write('$', (*){*) lword2str{*}(l), ',');
{$endif}
    end { GetLword };

    procedure GetWord(var w: word);
    begin
      FromLib(w, 2);
{$ifdef DBGgetI}
write('$', (*){*) word2str{*}(w), ',');
{$endif}
    end { GetWord };

    procedure GetByte(var b: byte);
    begin
      b:= 0; FromLib(b, 1);
{$ifdef DBGgetI}
write('$', (*){*) byte2str{*}(b), ',');
{$endif}
    end { GetByte };

    procedure GetUnits;
      var wrk, cnt: integer;
	  lidp: idp;
	  UnitRecord: record
	    unitnm: alpha;
	    ver,
	    date,
	    time:   cardinal;
	  end { UnitRecord };
    begin
      cnt:= 1; wrk:= 0; FromLib(wrk, 1);		{  external units }
      if MaxUnits <= wrk + UsedUnits + 1 then begin
	error(233); halt;
      end { if };
      utt:= addr(LvlArray(addr(ProcBuff)^)[UsedUnits]);
      inc(UsedUnits); utt^[0]:= ulvl;
      while wrk <> 0 do begin
	FromLib(UnitRecord, SizeOf(UnitRecord));
	with UnitRecord do begin
	  lidp:= GetInterface(unitnm, UnVisible, ver, date, time, UsedUnits)
	end { with };
	if lidp = nil then
	  error(-42)
	else begin
	  utt^[cnt]:= lidp^.Intface;
	end { if };
	inc(cnt); dec(wrk); inc(UsedUnits);
      end { while };
    end { GetUnits };

    function FindType(UnitNo, TypeNo: integer): typep;
      var TypeIds: idp;
    begin
      if UnitNo = 255 then		 { unit STANDARD    255 }
	TypeIds:= Units^.Intface^.ExpTypes
      else begin
	TypeIds:= utt^[UnitNo]^.ExpTypes;
      end { if };

    {$ifdef UniPas }						  {   }

      if not QueueSearch(TypeIds, 2, 16, TypeIds, TypeNo, $0280) then begin
	TypeIds:= nil;
      end { if };

    {$else}

      while (TypeIds <> nil) and (TypeIds^.TypeNo <> TypeNo) do begin
	TypeIds:= TypeIds^.next;
      end { while };

    {$endif}

      if TypeIds <> nil then
	FindType:= TypeIds^.IdType
      else begin
	error(-41);
      end { if };

    end { FindType };

    function NewType(form: Forms): typep;
      var sz: integer; ltp: typep;
    begin
      (*)
      case form of
	SubRange,
	ESubRange:  sz:= WordSizeOf(ltp^, SubRange	);
	Enumerated: sz:= WordSizeOf(ltp^, Enumerated	);
	Pointers:   sz:= WordSizeOf(ltp^, Pointers	);
	PowerSet:   sz:= WordSizeOf(ltp^, PowerSet	);
	Arrays:     sz:= WordSizeOf(ltp^, Arrays, false );
	PArrays:    sz:= WordSizeOf(ltp^, PArrays	);
	Strings:    sz:= WordSizeOf(ltp^, Strings	);
	Records:    sz:= WordSizeOf(ltp^, Records, false);
	PRecords:   sz:= WordSizeOf(ltp^, PRecords	);
	Files:	    sz:= WordSizeOf(ltp^, Files 	);
      else:	   {      : Scalar, Reals, Unrslvd, UnTyped }
	error(-36);
      end { case };
      GetMemWords(ltp, sz); FillWord(ltp^, sz, 0);
      {*)
      if form in [Scalar, Reals, Unrslvd, UnTyped] then error(-36);
      new(ltp); FillChar(ltp^, SizeOf(ltp^), 0);
      {*}		     {      /SizeOf(..., ...)/ }
      NewType:= ltp;
    end { NewType };

    procedure GetTypeIdents;
      var b: byte; lidp: idp; ltp: typep;
    begin
      GetByte(b);
      while b <> $ff do begin				{ Classes(b) = TypeId }
	if b <> ord(TypeId) then error(-34);
	new(lidp(*), TypeId(*));
	with lidp^ do begin
	  IdClass:= TypeId; next:= level^.ExpTypes;		{   }
	  GetByte(b); IdFlags:= b;
	  GetAlpha(IdName); GetWord(word(TypeNo)); GetByte(b); {    }
	  if b <> 0 then begin	       {      ' = ;' }
	    ltp:= FindType(b, TypeNo);
	    TypeNo:= 0; 		     {     unit    }
	  end { if };
	end { with lidp^ };
	EnterId(lidp); level^.ExpTypes:= lidp;
	GetByte(b);					       {   TForm }
	if lidp^.TypeNo <> 0 then begin
	  ltp:= NewType(Forms(b)); ltp^.TForm:= Forms(b);
	end { if };
	lidp^.IdType:= ltp;
	GetByte(b);
      end { while b <> $ff };
    end { GetTypeIdents };

    function  GetId(b: byte): idp;				       forward;
    procedure GetIdents;					       forward;

    procedure GetVpart(var fvarp: varntp);
      var b: byte; w: cardinal;
	  lvarp: varntp;
	  lidp: idp;
	  lstVprt: boolean;
    begin
      GetByte(b);
      if b = 2 then begin				    { common SubVpart }
	GetWord(w);
	while 0 < w do begin
	  if fvarp = nil then
	    error(-39)
	  else begin
	    dec(w); fvarp:= fvarp^.NextVpart;
	  end { if };
	end { while };
	fvarp:= fvarp^.SubVpart;
	(*) return {*) exit {*};
      end { if };
      lvarp:= nil; fvarp:= nil;
      while b <> $ff do begin
	if fvarp = nil then begin
	  if Parts(b) = TagField then
	    new(lvarp(*), TagField(*))
	  else begin
	    new(lvarp(*), Variant(*));
	  end { if };
	  fvarp:= lvarp; end
	else if lstVprt then begin
	  if Parts(b) = TagField then
	    new(lvarp^.LastVpart(*), TagField(*))
	  else begin
	    new(lvarp^.LastVpart(*), Variant(*));
	  end { if };
	  lvarp:= lvarp^.LastVpart; end
	else begin
	  if Parts(b) = TagField then
	    new(lvarp^.NextVpart(*), TagField(*))
	  else begin
	    new(lvarp^.NextVpart(*), Variant(*));
	  end { if };
	  lvarp:= lvarp^.NextVpart;
	end { if };
	with lvarp^ do begin (* Part:= Parts(b); *)
	  GetWord(word(VSize));
	  if b = ord(TagField) then begin
	    GetByte(b); lidp:= GetId(b);
	    if lidp^.IdClass <> TypeId then EnterId(lidp);{tag isn't type only}
	    TagId:= lidp; LastVpart:= nil; lstVprt:= true; end
	  else begin
	    GetWord(word(VarValue));
	    SubVpart:= fvarp^.LastVpart;      { prep for common SubVpart calc }
	    GetVpart(SubVpart);
	    lstVprt:= false; NextVpart:= nil;
	  end { if };
	end { with lvarp^ };
	GetByte(b);
      end { while b <> $ff };
    end { GetVpart };

    function GetType(No: word): typep;
      var b: byte; w: cardinal;
	  lidp: idp; ltp: typep;
	  recrd: LevelRecord;
	  wlevel: levelp;
    begin
      if No <> 0 then begin
	GetByte(b); ltp:= FindType(b, No); GetWord(w); end
      else begin
	GetWord(w);
	if w = 0 then begin {   }
	  GetWord(w);					  {    }
	  if w = $ffff then begin
	    GetType:= nil; (*) return() {*) exit {*};
	  end { if }; end
	else begin
	  GetByte(b);						{ get unit No }
	  GetType:= FindType(b, w);
	  (*) return() {*) exit {*};
	end { if };
	GetByte(b);						      { TForm }
	ltp:= NewType(Forms(b)); ltp^.TForm:= Forms(b);
      end { if };

      with ltp^ do begin
	TSize:= w;
	case TForm of
	  Enumerated: begin
	    new(LastConst(*), ECnstId(*));
	    lidp:= LastConst; GetWord(w);
	    GetAlpha(lidp^.IdName);
	    lidp^.No:= w;
	    lidp^.IdType:= ltp;
	    lidp^.IdClass:= ECnstId;
	    lidp^.next:= nil;
	    wlevel:= level; level:= ulvl; EnterId(lidp);
	    while 0 < w do begin
	      dec(w); new(lidp^.next(*), ConstId(*));
	      lidp:= lidp^.next; GetAlpha(lidp^.IdName);
	      lidp^.No:= w;
	      lidp^.IdType:= ltp;
	      lidp^.IdClass:= ECnstId;
	      lidp^.next:= nil;
	      EnterId(lidp);
	    end { while };
	    level:= wlevel;
	  end { When Enumerated };

	  ESubRange, SubRange: begin
	    RangeType:= GetType(0);
	    GetWord(word(tmin)); GetWord(word(tmax));
	  end;

	  Pointers: PointedTp:= GetType(0);

	  PowerSet: BaseType:= GetType(0);

	  PArrays, Arrays: begin
	    IndexType:= GetType(0); AElemType:= GetType(0);
	    if TForm = PArrays then GetWord(word(AByteLng));
	  end { when arrays & parrays };

	  Strings: begin
	    GetByte(b); StrSize:= b;
	  end { when strings };

	  PRecords, Records: begin
	    recrd.PrevLevel:= level;
	    recrd.Idents:= nil;
	    recrd.LvlKind:= Drec;
	    level:= addr(recrd);

	    if TForm = PRecords then GetWord(word(RByteLng));
	    GetVpart(VarPart); GetIdents;
	    FrstId:= recrd.Idents;

	    level:= recrd.PrevLevel;
	  end { when records or precords };

	  Files: begin
	    FileType:= GetType(0);
	    GetWord(word(RecBytes));
	  end { when Files };
	end { case };
      end { with ltp^ };
      GetType:= ltp;
    end { GetType };

    function GetId(b: byte): idp;
      var w: word; lidp, lidp1: idp; t: typep;
	  a: alpha; svNM: string[9];
    begin
      w:= b; GetByte(b);					  { get flags }
    {$ifNdef separate} (*   UniPas,        *)
      case Classes(w) of
	TypeId: begin
	  svNM:= nm;			 { preserve NM (to use SearchSection) }
	  GetAlpha(a);	  {     (      }
	  t:= GetType(0);	   {   Tag Type (variant record) }
	  (*){$W-}(*) move(a, nm[1], 8);	{     nm }
	  SearchSection(ulvl^.Idents, lidp);	  {     }
	  nm:= svNM;   { restore NM (    NM  , ) }
          {   lidp = nil          unit. }
          {      .                                      }
          if lidp = nil then begin                        {   . }
            new(lidp (*), TypeId, false (*));
            fillchar(lidp^, sizeof(lidp^ (*), TypeId, false (*)), #0);
            with lidp^ do begin
              IdClass:= TypeId; IdType:= t;
              IdName:= a; idflags:= b;
            end { with }; end
          else if (lidp^.IdType <> t) then begin            {     }
	    error(-46); 		    {         }
	  end { if };
	  (*) return(lidp); {*) GetId:= lidp; exit; {*}
	end { when TypeId };

	VarId:	 new(lidp (*),   VarId(*));
	ConstId: new(lidp (*), ConstId(*));
	ECnstId: new(lidp (*), ECnstId(*));

	FieldId: begin
	  if b and _packed <> 0 then
	    new(lidp (*), FieldId, true(*))
	  else begin
	    new(lidp (*), FieldId, false(*));
	  end { if };
	end { when FieldId };

	ProcId,
	FuncId: begin
	  if b and _inline <> 0 then
	    new(lidp (*), ProcId{/FuncId}, inlinePF(*))
	  else begin
	    new(lidp (*), ProcId{/FuncId}, declared(*));
	  end { if };
	end { when proc or func id };

      else(*):(*)     {         }
	error(-35);				  { UnitId, UnUnitId, LabelId }
      end { case };
    {$else} (*     UniPascal    Turbo *)
      if Classes(w) <> TypeId then
	new(lidp)		       {     new(..., ...) }
      else begin
	svNM:= nm;			 { preserve NM (to use SearchSection) }
	GetAlpha(a);	  {     (      }
	t:= GetType(0); 	   {   Tag Type (variant record) }
	move(a, nm[1], 8);			{     nm }
	SearchSection(ulvl^.Idents, lidp);	  {     }
	nm:= svNM;     { restore NM (    NM  , ) }
	if (lidp = nil) or (lidp^.IdType <> t) then begin   {     }
	  error(-46);			    {         }
	end { if };
	GetId:= lidp; exit;{     -   UniPascal }
      end { if };	    {           }
    {$endif}

      with lidp^ do begin
	IdClass:= Classes(w); IdFlags:= b; next:= nil;
	GetAlpha(IdName); IdType:= GetType(0);
	case Classes(w) of
	  VarId:   GetWord(word(IdAddr));

	  FieldId: begin
	    GetWord(word(IdOffset));
	    if b and _packed <> 0 then begin
	      GetWord(word(StartByte)); GetWord(word(ByteSize));
	    end { if };
	  end { when FieldId };

	  ConstId: begin
	    t:= IdType; IdValue.i:= 0;
	    if t^.TForm < Pointers then
	      GetLWord(IdValue.i)
	    else if t^.TForm = Pointers then begin
	      idValue.i:= 0; GetWord(word(addr(idValue.i)^)); end
	    else if t^.TForm = Strings then begin
	      idValue.CSegNo:= 0; GetWord(word(idValue.COffs)); end
	    else begin
	      error(-37);
	    end { if };
	  end { when ConstId };

	  ECnstId: begin
	    GetWord(word(No));
	  end { when ECnstId };

	  ProcId, FuncId: begin
	    if b and _inline <> 0 then begin
	      GetWord(word(InLineSz));
	      (*) GetMemWords(InLineCode, (inlinesz+1) div 2);
	      {*) GetMem(InLineCode, inlinesz); {*}
	      FromLib(InLineCode^, InLineSz); end
	    else if b and _interfaced <> 0 then begin
	      pf.seg:= 0; GetByte(b); pf.num:= b; GetWord(word(pf.psize));
	      if NextProc <= pf.num then NextProc:= pf.num + 1; end
	    else begin
	      error(-38);
	    end { if };

	    GetByte(b); lidp1:= lidp;			     { Get parameters }
	    while b <> $ff do begin
	      lidp1^.next:= GetId(b); lidp1:= lidp1^.next; GetByte(b);
	    end { while };
	    lidp1^.next:= nil;
	  end { when proc or func id };
	end { case };
      end { with lidp^ };
      GetId:= lidp;
    end { GetId };

    procedure GetIdents;
      var b: byte;
    begin
      GetByte(b);
      while b <> $ff do begin
	EnterId(GetId(b));		{       }
	GetByte(b);
      end { while };
    end { GetIdents };

    procedure GetTypes;
      var w: word;
    begin
      GetWord(w);
      while w <> $ffff do begin
	if GetType(w) = nil then { ok }; GetWord(w);
      end { while };
    end { GetTypes };

    procedure GetConstPool;
      var tdesc: TmpDesc;
	  wrk: natural;
	  buffer: packed array [0..255] of byte;
    begin
      tdesc:= _constpool_; CPoolSz:= ipc;
      to_temp(tdesc, 1); to_temp(CPoolSz, 2);
      while ipc <> 0 do begin
	wrk:= SizeOf(buffer); if ipc < wrk then wrk:= ipc;
	FromLib(buffer, wrk); to_temp(buffer, wrk);
	dec(ipc, wrk);
      end { while };
      inc(TempItems);
    end { GetConstPool };

  begin { GetInterface }
    if AlreadyUsed then begin	  {     , ..    }
      (*) return() {*) exit {*};	    {       }
    end { if };

    if UnitNotFound then begin					  (*) {$W-} (*)
      move(name, nm[1], 8); errsy:= ident; nm[0]:= #8; error(247)
    end { if };

{$ifdef DBGgetI}
writeln('<using ', name, '>');
{$endif}

    if CheckStart then begin		    {   ( LIBRARY) }
      new(ulvl(*), UnitLvl(*)); 			{   unit. }
      (*)FillWord(ulvl^, WordSizeOf(ulvl^, UnitLvl), 0);     { UniPascal fill }
      {*)FillChar(ulvl^,   SizeOf(ulvl^),	     0);  { Turbo Pascal Fill }
      with ulvl^ do begin			   (*     
	Idents:= nil; DBLids:= nil; PrevLevel:= nil;	FillChar/FillWord    *)
	LvlKind:= UnitLvl; UnitNo:= -1;      {       unit- }
	ver:= vdt.v; date:= vdt.d; time:= vdt.t;
      end { with ulvl^ };
      FromLib(ipc, 2);				    { get date size of a unit }
      MaxDsize:= 0; FromLib(MaxDsize, 1);      {    interface only UNIT }
      if UnitType = InterfacePart then begin	{      }
	dsize:= ipc;		 {     implementation unit }
	if MaxDsize <> 0 then begin    {     implementation }
	  error(251);			      { part of a interface only unit }
	end { if }; end
      else begin
	new(uidp (*), UnitId(*));
	with uidp^ do begin
	  IdType:= nil; next:= nil; IdName:= name;
	  IdFlags:= 0; IdClass:= UnitId; Intface:= ulvl;
	  if MaxDsize <> 0 then begin  {    interface only unit }
	    IdFlags:= _interfaced
	  end { if };
	  if UnitType = Unvisible then begin
	    IdClass:= UnUnitId;
	  end { if };
	end { with };
      end { if };
      GetUnits;
      FromLib(ipc, 2);				     { get constant pool size }
      if ipc <> 0 then begin
	if UnitType = InterfacePart then	      {   }
	  GetConstPool
	else begin
	  Seek(LibFile, FilePos(LibFile) + ipc);	     { skip constants }
	  if IOresult <> 0 then begin
	    errsy:= c_const; error(246);
	  end { if };
	end { if };
      end { if };

      level:= ulvl;
      GetTypeIdents;
      GetIdents;
      GetTypes;
      level:= LastLevel;
      if UnitType = InterfacePart then begin
	uidp:= ulvl^.Idents;
	while uidp <> nil do begin {      }
	  widp:= uidp^.link; EnterId(uidp); uidp:= widp;       { ..  LEVEL }
	end { while };
	uidp:= units^.next;	       {     unit- }
	while uidp <> nil do begin		{  STANDARD    }
	  EnterUnitId(uidp); uidp:= uidp^.next;
	end { while };
	GetInterface:= nil end
      else begin
	NextProc:= 2;		   { NextProc    implementation }
	widp:= Units;			  {    (   STANDARD) }
	while widp^.next <> nil do widp:= widp^.next;	 {   }
	widp^.next:= uidp; GetInterface:= uidp;
      end { if }
    end { if };

    (*) {*) Close(LibFile); if IOresult <> 0 then ; {*}
{$ifdef DBGgetI}
writeln;
writeln('<used ', name, '>');
{$endif}
  end { GetInterface };

{-----------------------------------------------------------------------------}