{-----------------------------------------------------------------------------}
{ Compiling Type declarations.				   (c) 1989, 1990 YGP }

    procedure typ(fsys: syset; var ftp: typep; var fsize: cardinal);
      var MayBePack, PackFlag: boolean;
	  Displ, UsedBytes: cardinal;

      procedure SimpleType(fsys: syset; var ftp: typep; var fsize: cardinal);
	label EndSimpType, BegSubRng, InvalidStrSize;
	var ltp:  typep;
	    llev: levelp;
	    lidp, lidp1: idp;
	    lval,
	    lcnt: integer;
	    lmin,
	    lmax: LongInt;
      begin	 { SimpleType. Deal with enumerations, subranges and type ids }
	{ A simple type is a type identifier, a subrange or an enumeration.   }

	if sy = file_sy then begin	 {     FILE   }
	  sy:= ident; (*){$W-}(*)	   {      }
	  fillchar(nm[5], 4, ' ');           {      }
	end { if };

	fsize:= 1;				 { for error recovary reasons }

	if not (sy in SimpTypeBegSys) then begin
	  ErrSkip(54, fsys + SimpTypeBegSys);
	  if not (sy in SimpTypeBegSys) then begin		    {$ifNdef Q}
            ltp:= nil; goto EndSimpType;                 {$else} halt; {$endif}
	  end { if };
	end { if };

	if sy = lpar then begin 		   { '(' start of enumeration }
	  llev:= level;      {Declared constants are local to innermost block.}
	  level:= LastLevel; {So save level and set level to be Last PF level.}

	  new(ltp (*), Enumerated(*));	    { create a structure for new type }
	  with ltp^ do begin
	    TSize:= 1; TForm:= Enumerated;
	  end { with ltp^ };

	  { Get constants }
	  lidp1:= nil; lcnt:= 0;
	  repeat insy;					  { Get Constant Name }
	    if sy <> ident then begin
	      error(50); {$ifdef Q} halt {$endif} end
	    else begin
	      new(lidp(*), ECnstId(*));
	      with lidp^ do begin
		move(nm[1], IdName, 8);
		IdType:= ltp; next:= lidp1;
		IdClass:= ECnstId;
		No:= lcnt;
		IdFlags:= _nochange;
	      end { with lidp^ };
	      EnterId(lidp); Inc(lcnt);
	      lidp1:= lidp;
	      insy;
	    end { if };
	    CheckSy(fsys+[comma, rpar]);
	  until sy <> comma;
	  ltp^.LastConst:= lidp1; level:= llev; 	      { restore level }
	  TestSy(rpar); end { when sy = lpar }
	else begin				     { TypeIdents & SubRanges }
	  if sy = ident then begin  { sy = ident,    => SubRange }
	    QualIdent([TypeId, ConstId, ECnstId, FuncId], lidp); {  ident-}
	    if lidp^.IdClass <> TypeId then goto BegSubRng;         {   }

	    insy;	     {   '..' =>      . }
	    if sy = dbl_period then begin{ start of SubRange dcl ( ) }
	      {        ,    }
	      {   .					  } {$ifNdef Q}
	      if not Undefined then				 {$endif} begin
		error(47);
	      end { if };					     {$ifdef Q}
	      halt(7);							{$else}
	      lidp:= UnDeclared[ConstId];
	      new(ltp(*), SubRange(*));
	      with ltp^, lidp^ do begin
		RangeType:= nil; TForm:= Subrange;
		tmin:= 0; tmax:= 0; TSize:= 1;
	      end { with };
	      insy; Constant(fsys); { skip '..' and get next const expression }
	      {            - }
	      { ..  ga.t = LongInt    .} {$endif} end
	    else begin			     { not '..' =>    }
	      ltp:= lidp^.IdType;
	      if ltp = str_t then begin
		if sy in FacBegSys + [minus_sy] then begin
		  TestSy(lbra); Constant(fsys+[rbra]);
		  if ga.t = scrd_t then begin
		    lval:= ga.Aval.i; inc(lval, 1 + ord(not odd(lval)));
		    if 256 = lval then
		      ltp:= mstr_t
		    else begin
		      new(ltp(*),Strings(*));
		      with ltp^ do begin
			StrSize:= lval-1; TForm:= Strings; TSize:= lval div 2;
		      end { with };
		    end { if }; end
		  else begin
InvalidStrSize:     ltp:= mstr_t;
		    {$ifNdef Q} if ga.t <> nil then {$endif} error(55);
		  end { if };
		  TestSy(rbra); end
		else begin
		  ltp:= mstr_t;
		end { if }
	      end { if };					    {$ifNdef Q}
	      if ltp <> nil then				 {$endif} begin
		fsize:= ltp^.TSize;
	      end { if }
	    end { if }; end { sy = ident }
	  else begin	       { a SubRange that does not start with an ident }
BegSubRng:		  {     -   Ident   }
	    new(ltp(*), SubRange(*));
	    with ltp^ do begin
	      TForm:= SubRange; TSize:= 1;
	      tmin:= 0; tmax:= 0;
	    end { with ltp^ };
	    Constant(fsys + [dbl_period]);			    {$ifNdef Q}
	    if ga.t <> nil then 				 {$endif} begin
	      if SubRange < ga.t^.TForm then
		err_nil(56)
	      else if Enumerated < ga.t^.TForm then begin
		ga.t:= ga.t^.RangeType;
	      end { if };
	    end { if };
								    {$ifNdef Q}
	    if ga.t <> nil then 				 {$endif} begin
	      with ltp^ do begin		    {    LongInt }
		RangeType:= ga.t;	     {       - }
		lmin:= ga.Aval.i; TSize:= 1;
	      end { with ltp^ };
	    end { if };

	    TestSy(dbl_period); Constant(fsys); lmax:= ga.Aval.i;
								    {$ifNdef Q}
	    if ga.t <> nil then 				 {$endif} begin
	      if (ESubRange =ga.t^.TForm) or (ga.t^.TForm =SubRange) then begin
		ga.t:= ga.t^.RangeType;
	      end { if };
	      if (ga.t <> ltp^.RangeType) then begin
		if (ga.t^.TForm = Scalar) and (ltp^.RangeType^.TForm = Scalar)
		  then ltp^.RangeType:= lint_t
		  else error(58);
	      end { if };
	    end { if };
								    {$ifNdef Q}
	    if ltp <> nil then					 {$endif} begin
	      with ltp^ do begin
		if (TForm = SubRange) and (RangeType <> nil) then begin
		  if RangeType = lint_t then begin
		    if 0 <= lmin then
		      if lmax <= 32767 then
			ga.t:= int_t
		      else if lmax <= 65535 then
			ga.t:= card_t
		      else begin
			ga.t:= lint_t
		      end { if }
		    else if (-32767 <= lmin) and (lmax <= 32767) then
		      ga.t:= int_t
		    else begin
		      ga.t:= lint_t;
		    end { if };

		    if ga.t = lint_t then begin
		      err_nil(190);
		    end { if };
		    RangeType:= ga.t;
		  end { if };

		  if lmax < lmin then begin
		    error(57); lmax:= lmin;
		  end { if };
		  tmin:= lmin; tmax:= lmax;
		  if {$ifNdef Q} (RangeType <> nil) and {$endif}
		     (RangeType^.TForm = Enumerated) then begin
		    TForm:= ESubRange;
		  end { if };
		end { if };
	      end { with };
	    end { if };
	  end { if };
	end { if };

EndSimpType:
	ftp:= ltp; CheckSy(fsys);
      end { SimpleType };

      procedure PtrType(var ftp: typep);
	var lidp, lidp1: idp;
	    a: alpha;
      begin
	new(ftp(*), Pointers(*));
	with ftp^ do begin
	  PointedTp:= nil; TSize:= 1; TForm:= Pointers;
	end { with ftp^ };
	insy;
	if sy = file_sy then begin		       {     }
	  sy:= ident; (*){$W-}(*) fillchar(nm[5], 4, ' ');
	end { if };

	if sy = ident then begin   { If we are compiling type declarations we }
	  { can see  forward  referenced types.  So don't report an error but }
	  { insert this forward type in frwrd queue.			      }
	  move(nm[1], a, 8);
	  if InTypeDecl then begin  {     level     }
	    {    ==>    forward reference type,     }
	    {      ,           type }
	    { .  :					      }
	    {				type p =    ^real;		      }
	    {				     real = integer;		      }
	    {      ,       real }
	    {  user defined.     QualIdent. 		      }

	    PrtErr:= false; SearchId([UnitId, UnUnitId], lidp, true);
	    PrtErr:= true;
	    if lidp <> nil then 	       {     QualIdent }
	      QualIdent([TypeId], lidp)
	    else begin
	      SearchSection(LastLevel^.Idents, lidp);
	      if (lidp <> nil) and (lidp^.IdClass <> TypeId) then begin
		lidp:= nil;    { possible forward referance }
	      end { if };
	    end { if };
	    if lidp = nil then begin		  { forward reference type id }
	      {    Work along the list of unresolved forward referenced types }
	      { and see if this has match one.				      }
	      ftp^.TForm:= Unrslvd; lidp1:= fwptr;
	      while lidp1 <> nil do begin      { if the names are equal, this }
		if lidp^.IdName = a then begin			  { match one }
		  lidp:= lidp1;       { Insert ftp in list of unresolved ptrs }
		  ftp^.NextUnrslvd:= lidp^.IdType; lidp^.IdType:= ftp;
		  lidp1:= nil; end			  { force while break }
		else begin
		  lidp1:= lidp1^.next;
		end { if };
	      end { while lidp1 <> nil };
	      if lidp = nil then begin	{ forward type id that not occure yet }
		if InPrgrm then
		  new(lidp(*), TypeId, false (*))
		else begin
		  new(lidp(*), TypeId, true (*));
		end { if };
		{  Create a structure for forward referenced type identifier, }
		{ but don't  enter  it in the tree.  Enter  it in the list of }
		{ unresolved frwrd types. All unresolved pointers of the same }
		{ type are linked together with  NextUnrslvd field and TypeId }
		{ of unresolved type points to first of them.		      }
		with lidp^ do begin
		  IdName:= a; IdType:= ftp;
		  next:= fwptr; IdClass:= TypeId; IdFlags:= 0;
		  if not InPrgrm then begin	      {  interface }
		    TypeNo:= 0; 			  {   }
		  end { if };
		end { with lidp^ };
		fwptr:= lidp;
	      end; end
	    else begin
	      ftp^.PointedTp:= lidp^.IdType;
	      if ftp^.PointedTp = str_t then ftp^.PointedTp:= Mstr_t;
	    end { if }; end { if InTypeDecl }
	  else begin
	    QualIdent([TypeId], lidp);	 {     qulification. }
	    ftp^.PointedTp:= lidp^.IdType;	{       }
	    if ftp^.PointedTp = str_t then begin {   var declarations }
	      ftp^.PointedTp:= Mstr_t;
	    end { if };
	  end { if };
	  insy; end { if sy = ident }
	else begin
	  error(50); {$ifdef Q} halt; {$endif}
	end { if }
      end { PtrType };

      function PackedType(ftp: typep): cardinal;
	var n: Cardinal;
	    NBytes: cardinal;
	    lbou, hbou: LongInt;
      begin
	NBytes:= 0; { PackedType returns number of bytes occupied by this type}
	if (ftp <> nil) and PackFlag then begin { 0 if this type is unpackable}
	  with ftp^ do begin
	    case TForm of
	      Scalar,
	      Enumerated,
	      SubRange,
	      ESubRange: begin
		GetBounds(ftp, lbou, hbou);
		if (   0 <= lbou) and (hbou <= 255) or
		   (-128 <= lbou) and (hbou <= 127) then begin
		  NBytes:= 1;
		end { if };
	      end { when scalar, ... ESubRange };

	      PArrays: begin
		GetBounds(IndexType, lbou, hbou);
		n:= hbou - lbou + 1;
		if LongInt(n * AByteLng) < $7fff then begin
		  NBytes:= n * AByteLng;
		end { if };
	      end { when PArrays };

	      PRecords: begin
		NBytes:= RByteLng;
	      end { when packed records };

	    end { case TForm };
	  end { with };
	end { if };
      PackedType:= NBytes;
      end { PackedType };

      procedure ArrayType(var ftp: typep);
	var ltp, ltp1, ltp2: typep;
	    lsize: cardinal;
	    NBytes, lmin, lmax, wrk: LongInt;
      begin
	insy; TestSy(lbra); ltp1:= nil;
	{   This repeat gets each of a list of indexes. Each time round, this }
	{ loop creates an  array structure  whose element  type is either the }
	{ array structure  created the next time round the loop,  or the type }
	{ follwing indexes.						      }
	repeat
	  if PackFlag then
	    new(ltp(*), PArrays(*))
	  else begin
	    new(ltp(*), Arrays(*));
	  end { if };

	  with ltp^ do begin
	    TForm:= Arrays; IndexType:= nil; AElemType:= ltp1;
	  end { with ltp^ };

	  ltp1:= ltp;

	  { Get one index type }
	  SimpleType(fsys+[comma, of_sy, rbra], ltp2, lsize);
	  ltp^.TSize:= 1;		      {       }
								    {$ifNdef Q}
	  if ltp2 <> nil then	 {$endif} { Check that the index is scalar or }
	    if ltp2^.TForm <= ESubRange 			  { subrange. }
	      then ltp^.IndexType:= ltp2
	      else error(61);

	  test:= sy <> comma;

	  if not test then insy;
	until test;

	TestSy(rbra); TestSy(of_sy);
	typ(fsys, ltp, lsize);			       { Get the element type }
	if (ltp <> nil) and (ltp^.TForm = Files) then begin
	  error(62);					  { Files not allowed }
	end { if };

	{ Calculate the run-time size of the type, and the size of the arrays }
	{ created for each index of the array.				      }
	NBytes:= PackedType(ltp);
	PackFlag:= PackFlag and (NBytes <> 0);
	repeat
	  with ltp1^ do begin
	    ltp2:= AElemType; AElemType:= ltp;
	    if IndexType <> nil then begin
	      GetBounds(IndexType, lmin, lmax);
	      wrk:= lmax - lmin + 1;
	      if PackFlag then begin
		TForm:= PArrays; AByteLng:= NBytes;
		NBytes:= Nbytes * wrk;
		if 65536 < NBytes then begin		       { stop packing }
		  NBytes:= 0; error(194);
		end { if };
		lsize:= succ(NBytes) div 2;
		PackFlag:= NBytes <> 0; end
	      else begin
		if 32767 < wrk * lsize then begin
		  error(194); lsize:= 1;
		end { if };
		lsize:= lsize * wrk;
	      end { if };
	      TSize:= lsize;
	    end { IndexType <> nil };
	  end { with ltp1^ };
	  ltp:= ltp1; ltp1:= ltp2;
	until ltp1 = nil;
	ftp:= ltp;
      end { ArrayType };

      procedure FieldList(fsys: syset; var fvarp: varntp);
	var nxt, nxt1, lidp: idp;
	    ltp: typep;
	    lsize: cardinal;
	    dummy: identifier;

	procedure Allocate(fidp: idp);
	  var NBytes: cardinal;
	begin
	  with fidp^ do begin
	    NBytes:= PackedType(IdType);
	    if NBytes <> 0 then begin
	      IdOffset:= displ; IdClass:= FieldId;
	      StartByte:= UsedBytes; ByteSize:= NBytes;
	      IdFlags:= _packed;
	      inc(UsedBytes, NBytes);
	      inc(displ, UsedBytes div 2);
	      UsedBytes:= UsedBytes mod 2; end
	    else begin
	      inc(displ, ord(0 < UsedBytes));	    { allign on word boundary }
	      MayBePack:= false; UsedBytes:= 0;
	      IdClass:= FieldId; IdOffset:= displ; IdFlags:= 0;
	      if IdType <> nil then inc(displ, IdType^.TSize);
	    end { if }
	  end { with fdip^ };
	end { Allocate };

	procedure VariantRecord;
	  var lvarp, lvarp1, lvarp2, lvarp3, lvarp4: varntp;
	      lidp, lidp1: idp;
	      present: boolean;        { The presents of an ident in tagfield }
	      MinSize, MinBytes, MaxSize, MaxBytes: cardinal;
	begin { VariantRecord }
	  inc(displ, UsedBytes div 2);
	  UsedBytes:= UsedBytes mod 2;
	  new(lvarp(*), TagField(*));
	  with lvarp^ do begin
	    TagId:= nil; LastVpart:= nil; (* Part:= TagField; *)
	  end { with };
	  fvarp:= lvarp;
	  insy;
	  if sy = ident then begin
	    if PackFlag
	      then new(lidp(*), FieldId, true(*))
	      else new(lidp(*), FieldId, false(*));
	    {	Fill in details, but don't enter it into the tree.            }
	    {	We don't know what kind of ident is this, a type or a var?    }
	    with lidp^ do begin
	      IdType:= nil; IdClass:= TypeId;
	      move(nm[1], IdName, 8); lidp^.IdFlags:= 0
	    end { with lidp^ };
	    present:= false;
	    PrtErr:= false; QualIdent([TypeId], lidp1); PrtErr:= true;
	    if lidp1 = nil then begin		    {      type id }
	      present:= true; EnterId(lidp);
	      insy; TestSy(colon);
	      lidp^.IdClass:= FieldId;
	      if PackFlag then lidp^.IdFlags:= _packed; {*** ? ***}
	    end { if };
	    if sy = ident then begin
	      QualIdent([TypeId], lidp1);		       { Get the type }
	      ltp:= lidp1^.IdType;				    {$ifNdef Q}
	      if ltp <> nil then				 {$endif} begin
		if ESubRange < ltp^.TForm then
		  error(76)
		else begin
		  lidp^.IdType:= ltp;
		  if 1 < ltp^.TSize then error(76);
		  lvarp^.TagId:= lidp;
		  if present then Allocate(lidp);
		end { if };
		insy;
	      end { if }; end
	    else begin
	      ErrSkip(50, fsys + [lpar, of_sy]); {$ifdef Q} halt; {$endif}
	    end { if }; end
	  else begin
	    ErrSkip(50, fsys + [lpar, of_sy]); {$ifdef Q} halt; {$endif}
	  end { if };
	  lvarp^.VSize:= displ + ord(0 < UsedBytes);
	  TestSy(of_sy);
	  MinSize:= displ;	MaxSize:= MinSize;
	  MinBytes:= UsedBytes; MaxBytes:= MinBytes;
	  lvarp1:= nil; 		 { lvarp1 points to last variant part }
	  repeat lvarp2:= nil;		    { links the variants in one group }
	    repeat		    { Get one group of constants 1,2,3: (...) }
	      Constant(fsys + [comma, colon, lpar]);
	      if (lvarp^.TagId <> nil) and
		 not TypeOK(lvarp^.TagId^.IdType) then begin
		error(77);
	      end { if };
	      new(lvarp3(*), Variant(*));
	      with lvarp3^ do begin
		(* Part:= Variant; *)
		VarValue:= ga.Aval.i; NextVpart:= lvarp1;
		{ All variants of this group are linked temporary by SubVPart }
		SubVPart:= lvarp2;
	      end { with lvarp3^ };
	      lvarp1:= lvarp3; lvarp2:= lvarp3;
	      test:= sy <> comma;
	      if not test then insy;
	    until test;
	    TestSy(colon); TestSy(lpar);
	    if sy = rpar then
	      lvarp2:= nil		 { now lvarp2 represents the SubVpart }
	    else begin
	      FieldList(fsys + [semicolon, rpar], lvarp2);
	    end { if };
	    while lvarp3 <> nil do	{ work down the group assigning sizes }
	      begin lvarp3^.VSize:= displ + ord(0 < UsedBytes);
	      lvarp4:= lvarp3^.SubVpart; lvarp3^.SubVpart:= lvarp2;
	      lvarp3:= lvarp4;		    {   SubVpart  := lvarp2 }
	    end { while lvarp3<>nil };	{          }
	    if (MaxSize < displ) or
	       (displ = MaxSize) and (MaxBytes < UsedBytes) then begin
	      MaxSize:= displ; MaxBytes:= UsedBytes;
	    end { if };
	    if sy <> rpar then
	      error(46)
	    else begin
	      insy; CheckSy(fsys + [semicolon])
	    end { if };
	    test:= sy <> semicolon;
	    if not test then begin
	      insy; displ:= MinSize; UsedBytes:= MinBytes;
	    end { if };
	  until test or (sy = end_sy) or (sy = rpar);
	  displ:= MaxSize; UsedBytes:= MaxBytes;
	  lvarp^.LastVpart:= lvarp1;
	end { VariantRecord };

      begin { FieldList }
	dummy.next:= nil; nxt1:= addr(dummy); ltp:= nil;
	if not (sy in [ident, case_sy]) then begin
	  ErrSkip(78, fsys +[ident, case_sy]);
	end { if };
	while sy = ident do begin  { Get each group of fields like a,b,c: ... }
	  nxt:= nxt1;	     { nxt1 points to last ident of the previos group }
	  repeat			  { Get each identfifier of the group }
	    if sy <> ident then begin	{ Create identifier and enter it into }
	      error(50); {$ifdef Q} halt; {$endif} end		   { the tree }
	    else begin
	      if PackFlag
		then new(lidp(*), FieldId, true(*))
		else new(lidp(*), FieldId, false(*));
	      with lidp^ do begin
		move(nm[1], IdName, 8);
		IdType:= nil; next:= nil;    { the fields are linked together }
		IdClass:= FieldId;			{ with the next field }
		IdFlags:= 0;
	      end { with lidp^ };
	      nxt^.next:= lidp; nxt:= lidp;	      { add lidp to the queue }
	      EnterId(lidp);
	      insy;
	    end { if };
	    if not(sy in [comma, colon]) then begin
	      ErrSkip(214, fsys + [comma, colon, semicolon, case_sy]);
	    end { if };
	    test:= sy <> comma;
	    if not test then insy;
	  until test;
	  TestSy(colon);
	  typ(fsys + [semicolon, case_sy], ltp, lsize);
	  if {$ifNdef Q} (ltp <> nil) and {$endif}
	     (ltp^.TForm = Files) then begin
	    error(62);
	  end { if };
	  nxt:= nxt1^.next;
	  while nxt <> nil do begin  { Work down the list of idents assigning }
	    with nxt^ do begin	{ offsets allocating space and filling in the }
	      IdType:= ltp; Allocate(nxt);			 { type field }
	      nxt1:= nxt; nxt:= next;		    { nxt1 points to last one }
	    end { with };
	  end { while };
	  if sy = semicolon then begin
	    insy;
	    if not(sy in [ident, end_sy, case_sy, rpar]) then begin
	      ErrSkip(78, fsys + [ident, end_sy, case_sy, rpar]);
	    end { if };
	  end { if };
	end { while sy = ident };
	fvarp:= nil;
	if sy = case_sy then VariantRecord;
	inc(displ, UsedBytes div 2);
	UsedBytes:= UsedBytes mod 2;
      end { FieldList };

      procedure RecordType(var ftp: typep);
	var RecLevel: LevelRecord;
	    ltp: typep;
	    lvarp: varntp;
      begin
	insy;
	RecLevel.PrevLevel:= level;			   { Make a new level }
	RecLevel.Idents:= nil; RecLevel.LvlKind:= rec;

	level:= addr(RecLevel);
	displ:= 0;			       { Set the initial displacement }
	UsedBytes:= 0;				      { for the field to zero }
	MayBePack:= true;		      { Say, the record may be packed }
	FieldList(fsys - [semicolon] + [end_sy], lvarp); { Get the field list }

	{ Create the structure for the record }
	PackFlag:= PackFlag and MayBePack;
	if PackFlag then begin
	  new(ltp(*), PRecords(*)); ltp^.TForm:= PRecords; end
	else begin
	  new(ltp(*), Records(*));  ltp^.TForm:= Records;
	end { if };

	with ltp^ do begin
	  FrstId:= RecLevel.Idents;
	  VarPart:= lvarp; TSize:= displ + ord(UsedBytes <> 0);
	  if PackFlag then begin
	    RbyteLng:= displ * 2 + UsedBytes;
	  end { if };
	end { with ltp^ };
	level:= RecLevel.PrevLevel; TestSy(end_sy);
	ftp:= ltp;
      end { RecordType };

      procedure SetType(var ftp: typep);
	var ltp, ltp1: typep;
	    lsize: cardinal;
      begin
	insy; TestSy(of_sy);
	SimpleType(fsys, ltp1, lsize);		       { Get the element type }
								    {$ifNdef Q}
	if ltp1 <> nil then					 {$endif} begin
	  if (ESubRange < ltp1^.TForm) then begin { Check it is a simple type }
	    error(79);		   { 'cause SimpleType may fetch a type ident }
	    {$ifNdef Q} ltp1:= nil; {$else} halt; {$endif};
	  end { if };
	end { if };

	new(ltp(*), PowerSet(*));
	with ltp^ do begin
	  TForm:= PowerSet;					    {$ifNdef Q}
	  if ltp1 = nil then
	    TSize:= 0
	  else							 {$endif} begin
	    GetBounds(ltp1, ga.amin, ga.amax);
	    TSize:= (ga.amax + 16) div 16;   { Check the type is small enough }
	    if (ga.amin < 0) or(255 < ga.amax) then begin { to be represented }
	      error(195); TSize:= 0;		{ in the set size implemented }
	      {$ifNdef Q} ltp1:= nil; {$else} halt; {$endif}
	    end { if };
	  end { if };
	  BaseType:= ltp1;
	end { with ltp^ };
	ftp:= ltp;
      end { SetType };

      procedure FileType(var ftp: typep);
	var ltp, ltp1: typep;
	    lsize: cardinal;
      begin
	insy;
	if sy <> of_sy then
	  ftp:= file_t
	else begin
	  TestSy(of_sy);
	  new(ltp(*), Files(*));
	  with ltp^ do begin
	    TForm:= Files; RecBytes:= 0;
	  end { with ltp^ };
	  typ(fsys, ltp1, lsize);
	     { file of file not allowed }
	  if (ltp1 <> nil) and (ltp1^.TForm = Files) then begin
	    error(62);
	  end { if };
	  if PackFlag then
	    lsize:= PackedType(ltp1)
	  else begin
	    lsize:= 0;
	  end { if };
	  ltp^.FileType:= ltp1; ltp^.RecBytes:= lsize;
	  { Allocate space for file variable }
	  ltp^.TSize:= 8;				 { File variable size }
	  ftp:= ltp;
	end { if };
      end { FileType };

    begin { typ }
      PackFlag:= Opt.AutoPack; ftp:= nil;
      if not(sy in TypeBegSys) then begin
	ErrSkip(53, fsys + TypeBegSys);
      end { if };

      if sy in TypeBegSys then begin
	if sy in SimpTypeBegSys then
	  SimpleType(fsys, ftp, fsize)
	else begin
	  if sy = arrow_sy then
	    PtrType(ftp)
	  else begin					     { packable types }
	    if sy = packed_sy then begin
	      insy; PackFlag:= true;
	      if not(sy in TypeDels) then begin
		ErrSkip(53, fsys+TypeDels);
	      end { if };
	    end { if };
	    case sy of
	      array_sy:  ArrayType(ftp);
	      record_sy: RecordType(ftp);
	      set_sy:	 SetType(ftp);
	      file_sy:	 FileType(ftp);
	    end { case sy };
	  end { if };
	end { if };
	CheckSy(fsys);
      end { if };
								    {$ifNdef Q}
      if ftp = nil then
	fsize:= 1
      else							 {$endif} begin
	fsize:= ftp^.TSize;
      end { if };
    end { typ };

    procedure TypeDeclaration;
      var lidp, lidp1, lidp2: idp;
	  ltp: typep;
	  DupName: boolean;
	  lsize: cardinal;
	  lname: alpha;

      procedure ResolveType(fidp: idp; ftp: typep);
	var ltp1, ltp2: typep;
      begin
      if ftp = str_t then ftp:= Mstr_t;
      ltp1:= fidp^.IdType;		      {   Only pointers cause forward }
      repeat ltp2:= ltp1^.NextUnrslvd; { references,  so  fill in the element }
	ltp1^.TForm:= Pointers;        { type of the pointer type, by working }
	ltp1^.PointedTp:= ftp;	       { down all  types  that points to this }
        if ltp1 = ftp then begin       { unresolved  type.  They  are  linked }
          error(7);                    { together by NextUnrslvd field.       }
        end { if };                          {     }
        ltp1:= ltp2;                       {        }
      until ltp1 = nil;                        {       }
      end { ResolveType };

    begin { TypeDeclaration }
      InTypeDecl:= true; fwptr:= nil;	  { fwptr - list with frwrd ref types }

      if sy <> ident then ErrSkip(50, fsys_ident);     {  ident   }

      while sy = ident do begin        { Repeatedly get one type declaration. }
	move(nm[1], lname, 8); SearchSection(level^.Idents, lidp);
	{             }
	{           error.		      }
	DupName:= lidp <> nil; if DupName then Error(52);
	insy;
	if (sy <> colon) and (sy <> becomes) then  { Check for the equal sign }
	  TestSy(eq_sy)
	else begin	     { but don't worry if becomes or colon is reached }
	  error(39); insy;
	end { if };

	typ(fsys + [semicolon], ltp, lsize);		       { Get the type }

	{   Work along the list of unresolved forward	    }
	{ reference types and see if this has resolved one. }
	lidp1:= fwptr; lidp:= nil;
	{   Work along the list of unresolved forward reference types and see }
	while lidp1 <> nil do begin		  { if this has resolved one. }
	  if lidp1^.IdName = lname then begin  { If the names are equal, this }
	    lidp:= lidp1;		    { resolved one. Get resolved type }
	    ResolveType(lidp, ltp);
	    if lidp = fwptr then	   { Delete this type from fwptr list }
	      fwptr:= fwptr^.next			    { lidp2 undefined }
	    else begin
	      lidp2^.next:= lidp^.next; 		      { lidp2 defined }
	    end { if };
	    lidp1:= nil; end				  { force while break }
	  else begin
	    lidp2:= lidp1; lidp1:= lidp1^.next;
	  end { if };
	end { while lidp1 <> nil };

	if lidp = nil then begin	   { this type isn't forward declared }
	  if InPrgrm then			    { Get space for one ident }
	    new(lidp (*), TypeId, false(*))
	  else begin
	    new(lidp (*), TypeId, true(*));
	  end { if };
	  lidp^.IdName:= lname; lidp^.IdClass:= TypeId; lidp^.IdFlags:= 0;
	end { if };

	if not InPrgrm then begin		      {  interface }
	  lidp^.TypeNo:= TypeCnt; TypeCnt:= TypeCnt + 1;    {    }
	  lidp^.next:= ExportTypes; ExportTypes:= lidp;        {  }
	end { if };

	lidp^.IdType:= ltp;			     { Fill in the type field }
	if not DupName then EnterId(lidp);
	if sy <> semicolon then
	  error(47)
	else begin
	  insy; CheckSy(fsys_ident);
	end { if };
      end { while sy = ident };

      { ----- Now we are sure that sy <> ident ==> NM is free for use. ------ }
      {  If the forward list isn't empty at the end of the type declarations, }
      { then these are undeclared types and must be reported. Or may be these }
      { are the type identifiers declared outside?			      }

      PrtErr:= false;
      while fwptr <> nil do begin
	nm[0]:= #8; (*){$W-}(*) move(fwptr^.IdName, nm[1], 8);
	SearchId([TypeId], lidp, true);
	if lidp <> nil then
	  ResolveType(fwptr, lidp^.IdType)
	else begin
	  ErrSy:= ident; Error(60);				    {$ifNdef Q}
	  ResolveType(fwptr, nil);			 {$else} halt; {$endif}
	end { if };
	fwptr:= fwptr^.next;
      end { while fwptr <> nil };
      PrtErr:= true;

      InTypeDecl:= false;
    end { TypeDeclaration };

{-----------------------------------------------------------------------------}