{*****************************************************************************}
{*									     *}
{*			      UniPascal Compiler			     *}
{*		       (c) 1989, 90 George Petrov /YGP/ 		     *}
{*									     *}
{*              Version:           1.61     ( Cross Compiler )               *}
{*		Language:	   UniPascal  ( Turbo Pascal )		     *}
{*		Operating System:  UniDOS     (       MS-DOS )		     *}
{*		Computer:	    601 ( IBM PC/XT/AT )		     *}
{*									     *}
{*****************************************************************************}
{ $define Q }			  { Quick compilation (but no error recovary) }
					{    quick     }

							   { Compiler Options }
(*) {$I-,R-}						      { for UniPascal }
{*) (*$A-,B-,E+,F-,I-,N+,O-,R-,S+,V-*)
    (*$D+,L+*)
    (*$M 32767,32767,655360*)				   { for Turbo Pascal }

program {$ifdef Q} UPCq {$else} UPC {$endif} (output, message);
  (*){------- use include files when compiling with UniPascal compiler -------}

  {$I	   globals.upc	}			{ Global consts, types, vars. }
  {$I	   forward.upc	}	 { forward declared procedures and functions. }
  {$I	   inlines.upc	}		   { InLine proc/funcs for UniPascal. }
  {$I	   misc_pf.upc	}			   { Miscellaneous proc/funs. }
  {$I	errhandler.upc	}				     { Error handler. }
  {$I	   lexical.upc	}     { Lexical analisys. INSY, CompilerOptions, etc. }
  {$I	    finish.upc	}			     { Finish up compilation. }
  {$I	 alloccnst.upc	}	{ allocate constant (write in temporary file. }
  {$I	 constants.upc	}		   { calculating constant expression. }
  {$I	  bodypart.upc	}		     { compiling body of a procedure. }
  {$I   usesclause.upc  }                            { compiling USES clause. }
  {$I	  getintfc.upc	}	     { get compiled interface part of a unit. }
  {$I	 makeintfc.upc	}	  { create file for interface part of a unit. }
  {$I declarations.upc	}			    { compiling declarations. }
  {$I	initialize.upc	}		   { Initializing UniPascal Compiler. }

  {*)(*-------- use units when compiling with Turbo Pascal compiler ---------*)

      uses UniCRT, UPCglobals, UPClexical, UPCinit, UPCmisc,
		   UPCfinish,  UPCunits,   UPCdecl, UPCbody,
		   UPCinlines;

  {---------------------------------------------------------------------------}
									 (*){*)
  label exit;								    {*}

  (*) segment (*)
  function CheckUndefined(fidp: idp): boolean;
    var svNME: string[8];
  begin 		     {  TRUE       }
    CheckUndefined:= false;
    move(nm, svNME, sizeof(svNME));
    while fidp <> nil do begin
      if (fidp^.IdClass in [ProcId, FuncId]) then begin
	CheckUndefined:= true;
	if (fidp^.IdFlags and _forward <> 0) then begin
	  (*){$W-}(*) move(fidp^.IdName, nm[1], 8); nm[0]:= #8;
	  ErrSy:= ident; EPosition:= -1; error(59); PrtErr:= false;
	end { if };
      end { if };
      fidp:= fidp^.link;
    end { while };
    move(svNME, nm, sizeof(nm)); PrtErr:= true;
  end { CheckUndefined };

  (*) segment (*)
  procedure ReopenCodeFile;
    var wrk, wrk1: string[127];
  begin
    close(CodeFile);				   { close compiled interface }
    wrk:= SYMname^;
    while (wrk <> '') and not(wrk[length(wrk)] in ['\', ':']) do dec(wrk[0]);
    insert(prognm, wrk, length(wrk)+1); insert('.SYM', wrk, length(wrk)+1);
    remove(wrk);	       (*) {*) if IOresult <> 0 then ; {  }
    wrk1:= wrk;              {    UniDOS      }
    rename(SYMname^, wrk1); {        : "  " }
    if IOresult <> 0 then error(248);
    SYMname^:= wrk;

    CURname:= BDYname;
    (*) Open(CodeFile, CURname^, temporary);
    {*) (*          *)
	insert('codefile.tmp', CURname^, length(CURname^)+1);
	Assign(CodeFile, CURname^); rewrite(CodeFile, 1); {*}
    if IOresult <> 0 then begin
      last.s:= CURname; errsy:= c_const; error(249);
    end { if };
    fillchar(ProcBuff, sizeof(ProcBuff), #0);
    BlockWrite(CodeFile, ProcBuff, 512);
    if IOresult <> 0 then Error(248);
    LastPara:= 0; word(SegStart):= $ffff; OKcode:= 1;
    TestSy(implmnt_sy);
  end { ReopenCodeFile };

  label EndCompile;
  var heap: pointer;

begin { UPC }
  UserBreak:= true;
  initialize;	{ Initialize Compiler. Read in first symbol. Open source file }

  if Compilation = implmnt_sy then begin     { Compiling implementation unit? }
    Cdate:= 0; Ctime:= 0; Cver:= 0;
    if GetInterface(level^.Proc^.IdName,
		    InterfacePart, Cver, Cdate, Ctime, 0) <> nil then ;
  end { if };

  if Compilation in [unit_sy, intface_sy] then begin   { Compiling full unit? }
    if Compilation = unit_sy then TestSy(intface_sy);
    if sy = uses_sy then UsesClause;
    Declarations;
    CreateInterface;
    if ((Compilation = intface_sy) or IntfcOnlyU) and (sy = end_sy) then begin
      writeln; Compilation:= intface_sy; goto EndCompile;
    end { if };
    InDecl:= true;	  {       include/object file }
    ReopenCodeFile;
  end { if };

  InPrgrm:= true; InDecl:= true;		{  ,   }
  if sy = uses_sy then UsesClause;		         {  USES- }
  mark(level^.MarkHeap);    {     ( release) }

  repeat
    if InDecl then
      Declarations
    else begin				     {      }
      if CheckUndefined(level^.Idents) then begin	 {    }
	writeln;
	writeFname; write(message, level^.proc^.IdName: 9+LexLevel, #24#13);
        (*)
	write(Ifile[Ilevel].fname:15, '(', LLineCnt: 4, ')',
	      level^.proc^.IdName: 9+LexLevel);
        {*)
        if length(Ifile[Ilevel].fname) <= 15 then
          write(Ifile[Ilevel].fname:15)
        else begin
          write(MinimizeFname(Ifile[Ilevel].fname): 15);
        end;
        write('(', LLineCnt: 4, ')', level^.proc^.IdName: 9+LexLevel);
        {*}
	WriteFname;
      end { if };
      Opt.Warning:= true;
      TestSy(begin_sy);
      {repeat                    { repeat is for error recovary -    }
        ProcInit;        { repeat-        }
        BodyPart;                   {    ProcInit/Exit }
        ProcExit;      {            }
      {until test or (sy in BlckBegSys);  {          }
      if test then begin           { test      ProcExit }
	if sy = semicolon then insy;			  { don't skip period }
	if (sy in BlckBegSys) or (LexLevel = 0) then begin
	  InDecl:= (sy in BlckBegSys) and (sy <> begin_sy);
	  if level^.proc^.IdFlags and _overlay	<> 0 then begin   {$ifdef SWAP}
                                                                       writeln;
                      writeln('FileSize: ', (FileSize(CodeFile) + 511) div 512,
                                  ', OK ', OKcode, ', SS ', SegStart); {$endif}
	    FinishSegment;
	  end { if };
	  heap:= level^.MarkHeap;
	  LastLevel:= level^.PrevLevel;
	  level:= LastLevel;
	  if level <> nil then begin
	    ProcNo:= level^.Proc^.pf.num;
	    SegNo:= level^.Proc^.pf.seg;
	    dsize:= level^.SaveDS;
	    Dec(LexLevel);
	  end { if };
	  release(heap); end
	else begin
	  ErrSkip(38, BlckBegSys + StatBegSys - [case_sy]); InDecl:= true;
	end { if }; end
      else InDecl:= true;	      {      repeat  }
    end { if };
  until level = nil;

EndCompile:
  UserBreak:= false;
{$ifdef finish}
  writeln('before EXIT:');
{$endif}
exit:

{$ifdef finish}
  writeln('before FinishUp');
{$endif}

  if not InInit then FinishUp;

{$ifdef finish}
  writeln('FinishUP exited!');
{$endif}

  {      BUG  ROM-a  Y-code (v1.60) }
  (*) {*) halt(errlevel);                              { quit with error level }

{$ifdef finish}
  writeln('After HALT');
{$endif}
end { UPC }.

conditional compilation symbols

PSA	-       Pascal Structure Analyst  - 
DBGgetI - debug for get interface
getCFG	- debug for get config file (config.upc)
makeI	- debug for make interface
rdSRC	- debug information for read source (read text block from buffer)
TestSY	- debug information on lexical analisys
SWAP    - debug for segment swapping
wrIO    - debug for IO errors
finish  - denug for FinishUp
-------------------------------------------------------------------------------
{$ifdef Check_for_Duplicate_import}
             
             
             .
              ,   
     .
{$endif}

{$ifdef OBJ_Version_Check}
     ( )    OBJ   
    .   OBJ     .
{$endif}